/* (c) https://github.com/MontiCore/monticore */
/* generated by template templates.de.monticore.lang.montiarc.tagschema.ValuedTagType*/


package nfp.PowerTagSchema;

import de.monticore.lang.montiarc.tagging._symboltable.TagKind;
import de.monticore.lang.montiarc.tagging._symboltable.TagSymbol;
import org.jscience.physics.amount.Amount;

import javax.measure.quantity.Power;
import javax.measure.unit.Unit;

/**
 * Created by ValuedTagType.ftl
 */
public class PowerCmpSymbol extends TagSymbol {
  public static final PowerCmpKind KIND = PowerCmpKind.INSTANCE;

  public PowerCmpSymbol(Amount<Power> value) {
    this(KIND, value);
  }

  public PowerCmpSymbol(Number number, Unit<Power> unit) {
    this(KIND, number, unit);
  }

  protected PowerCmpSymbol(PowerCmpKind kind, Amount<Power> value) {
    super(kind, value);
  }

  protected PowerCmpSymbol(PowerCmpKind kind, Number number, Unit<Power> unit) {
    this(kind, number.toString().contains(".") ?
      Amount.valueOf(number.doubleValue(), unit) :
      Amount.valueOf(number.intValue(),
          unit));
  }

  public Amount<Power> getValue() {
     return getValue(0);
  }

  public Number getNumber() {
    return getValue().getExactValue();
  }

  public Unit<Power> getUnit() {
    return getValue().getUnit();
  }

  @Override
  public String toString() {
    return String.format("PowerCmp = %s %s",
      getNumber(), getUnit());
  }

  public static class PowerCmpKind extends TagKind {
    public static final PowerCmpKind INSTANCE = new PowerCmpKind();

    protected PowerCmpKind() {
    }
  }
}
